;	VGA Monitor Tester v.2.0
;	(c) 2001-03 Yuri Lysenkov aka YUSoft
;	http://www.hardw.net/russian/vga-test.php
;
;	based on the Eric Schlaepfer's MDA/CGA Tester
;	http://www.sonic.net/~schlae/pic.html

;	Ceramic resonator 4MHz, Tcycle=1mkS

;	(VGA: Video mode 640x480  HSync=-31,4KHz 1/HSync=32cycles
;				  VSync=-60Hz 1/VSync=16667cycles

;	processor 16f84
	list p=16f84, f=inhx8m

	#include <p16f84.inc>
	__config  _XT_OSC & _WDT_OFF & _PWRTE_ON

TopCount:	equ	 0x0C
BotCount:	equ	 0x0D
LCount0:	equ	 0x10
LCount1:	equ	 0x11
LCount2:	equ	 0x12
LCount3:	equ	 0x13
LCount4:	equ	 0x14
LCount5:	equ	 0x15
LCount6:	equ	 0x16

blank:	macro
	bcf     PORTB, 1
	endm
point:	macro
	bsf     PORTB, 1
	endm

HSync:	macro
	bcf     PORTB, 3      ; horiz sync
	nop
	bsf     PORTB, 3      ; horiz sync
	endm

VSync:	macro
	bcf     PORTB, 4 	; vert sync
	nop
	nop
	nop
	nop
	nop
	bsf     PORTB, 4	; vert sync
	endm

	org	0
	goto	Start
	org     0x20            ; start address 0

Start:	clrf    PORTB
	bsf     STATUS, RP0	; select bank 1
	clrf   	TRISB
	bcf     STATUS, RP0	; select bank 0
	bsf     PORTB, 4 	; vert sync

LoopV:	VSync			; 1-6

	blank      		; 1
	movlw   D'208'
	movwf   TopCount
	movwf   BotCount
	movlw   D'15'
	movwf   LCount0
	movwf   LCount1
	movwf   LCount2
	movwf   LCount3
	movwf   LCount4
	movwf   LCount5
	movwf   LCount6
				
BlankLoopTop:                   ; now, the blank area at the top
	blank      		; 1
	nop                     ; 2
	nop			; 3
	call    Delay10mkS     	; 4-13
	call    Delay10mkS     	; 14-23
	
	nop			; 24
	nop			; 25
	nop			; 26

	HSync                   ; 27-29

	decfsz  TopCount      	; 30
	goto    BlankLoopTop  	; 31
	nop			; 32 (207*32=6624)

	#include <text.inc>	; 7*15*32=3360
			      
BlankLoopBot:                   ;now, the blank area at the bottom
	blank      	      	; 1
	nop                   	; 2
	nop		      	; 3
	call    Delay10mkS    	; 4-13
	call    Delay10mkS    	; 14-23
	
	nop			; 24
	nop			; 25
	nop			; 26

	HSync		      	; 27-29

	decfsz  BotCount      	; 30
	goto    BlankLoopBot  	; 31

	goto    LoopV		; 32 (207*32=6624)

Delay10mkS:
	nop
	nop
	nop
	nop
	nop
	nop
	return

	end